## why 2.34

=== atp/Makefile ===
# List of ML files to compile as a library. This leaves out the following
# which are probably not much use:
#
# sigma.ml       (Sigma-formulas and evaluator-by-proof)
# turing.ml      (OCaml implementation of Turing machines)
# undecidable.ml (Proofs related to undecidability results)
# bhk.ml         (Trivial instance of BHK interpretation)
# many.ml        (Example relevant to many-sorted logic)
# hol.ml         (Simple higher order logic setup)

#MLFILES = lib.ml intro.ml formulas.ml prop.ml propexamples.ml           \
          defcnf.ml dp.ml stal.ml bdd.ml fol.ml skolem.ml               \
          herbrand.ml unif.ml tableaux.ml resolution.ml prolog.ml       \
          meson.ml skolems.ml equal.ml cong.ml rewrite.ml               \
          order.ml completion.ml orewrite.ml eqelim.ml                  \
          paramodulation.ml decidable.ml qelim.ml cooper.ml             \
          complex.ml grobner.ml real.ml geom.ml interpolation.ml        \
          combining.ml transition.ml temporal.ml model.ml ltl.ml        \
          ste.ml lcf.ml hilbert.ml lcfprop.ml lcffol.ml checking.ml     \
          tactics.ml

MLFILES = lib.ml intro.ml formulas.ml prop.ml propexamples.ml           \
	  defcnf.ml dp.ml fol.ml skolem.ml herbrand.ml qelim.ml         \
	  cooper.ml fourier_motzkin.ml

# The default is to build a bytecode executable

bytecode: example.ml atp.cmo; ocamlc -o example nums.cma atp.cmo example.ml

# Alternatively, produce native code

compiled: example.ml atp.cmx; ocamlopt -o example nums.cmxa atp.cmx example.ml

# Make the appropriate object for the main body of code

atp.cmx: atp.ml; ocamlopt -w ax -c atp.ml

atp.cmo: atp.ml; ocamlc -w ax -c atp.ml

# Make the camlp4 quotation expander

Quotexpander.cmo: Quotexpander.ml; ocamlc -I +camlp4 -c Quotexpander.ml

# Extract the non-interactive part of the code

atp.ml: $(MLFILES); ./Mk_ml_file $(MLFILES) >atp.ml

# Clean up

clean:; -rm -f atp.cma atp.cmi atp.cmo atp.cmx atp.o atp.ml example example.cmi example.cmo example.cmx example.o Quotexpander.cmo Quotexpander.cmi

=== doc/Makefile ===
HEVEA=hevea -noiso -entities -exec xxdate.exe -fix

all: main.pdf manual.ps $(KFILES) krakatoa.pdf \
	sourcepp jessie.pdf krakatoa.html jessie.html \
	index.html

install: all
	cp krakatoa.pdf jessie.pdf krakatoa.html jessie.html \
		why_frama_c2-mps.png why_frama_c2.mps *.png \
		/users/www-perso/projets/krakatoa
	mkdir -p /users/www-perso/projets/krakatoa/jessie
	cp jessie/*.png /users/www-perso/projets/krakatoa/jessie
	cp index.html /users/www-perso/projets/krakatoa/index.html

index.html:: why_frama_c2-mps.png

%.html: %.prehtml
	yamlpp  $< -o $@

doc.dvi: doc.tex rules.tex macros.tex code.tex dep.ps

SRCFILES=../src/loc.mli ../src/logic.mli ../src/types.mli \
	 ../src/ptree.mli ../src/ltyping.mli ../src/ast.mli ../src/env.mli \
         ../src/typing.mli ../src/typing.ml ../src/wp.mli ../src/wp.ml \
	 ../src/monad.mli ../src/monad.ml ../src/mlize.mli ../src/mlize.ml

KFILES=Lesson1_max.pp \
	Lesson1_sqrt.pp Lesson1_sqrtbody.pp Lesson1_sqrtloopinv.pp \
	Lesson1_lemmas.pp Lesson1_pragma.pp Lesson1_sqrtdecr.pp \
	Arrays_findMax.pp Arrays_findMaxbody.pp \
	Arrays_findMax2.pp Arrays_shift.pp \
	Purse.pp Purse0.pp Purse_test1.pp Purse_test2.pp Purse2.pp \
	Purse_withdraw2.pp \
	Flag.pp Flag1.pp Flag_inv.pp Flag_isMonochrome.pp Flag_flag.pp \
	Flag_swap.pp Flag_body.pp \
	contracts.bnf lexpr.bnf \
	Gcd-nospec.pp Gcd-spec.pp Gcd.pp Gcd-lemmas.pp

# for jessie
SNIPPET=$(wildcard codes/*.c)
SNIPPETPP:=$(patsubst codes/%.c, texpp/%.cpp, $(SNIPPET))

sourcepp: $(SNIPPETPP) $(EXAMPLESPP)

why_frama_c1.mps: why_frama_c.ml
	mlpost -pdf -latex jessie.tex why_frama_c.ml

why_frama_c1-mps.pdf: why_frama_c1.mps
	mptopdf why_frama_c1.mps 

why_frama_c2.mps: why_frama_c.ml
	mlpost -pdf -latex jessie.tex why_frama_c.ml

why_frama_c2-mps.pdf: why_frama_c2.mps
	mptopdf why_frama_c2.mps 

why_frama_c2-mps.png: why_frama_c2-mps.pdf
	pdftoppm -r 150 why_frama_c2-mps.pdf | pnmtopng -transparent white > why_frama_c2-mps.png

dep.ps:
	(cd ../src; ocamldep *.ml* | ocamldot | dot -Tps) > dep.ps

code.tex: $(SRCFILES)
	ocamlweb --no-preamble -o $@ $(SRCFILES)

logo-why.pdf: logos.tex
	pdflatex logos.tex

logo-why.png: logo-why.pdf
	pdftoppm logos.pdf | pnmcrop | pnmtopng > logowhy.png

logo-why-small.png:

manual.ps: manual.tex version.tex
	latex manual
	latex manual
	makeindex manual
	latex manual
	dvips manual.dvi -o manual.ps

manual.html: manual.tex version.tex
	rm -f manual.aux
	$(HEVEA) manual.tex

caduceus.ps: caduceus.tex version.tex
	latex caduceus
	bibtex caduceus
	makeindex caduceus
	latex caduceus
	latex caduceus
	dvips caduceus.dvi -o caduceus.ps

caduceus.html: caduceus.tex version.tex
	rm -f caduceus.aux
	$(HEVEA) caduceus.tex

krakatoa.pdf: $(KFILES) krakatoa.tex version.tex
	pdflatex krakatoa.tex
	bibtex krakatoa
	makeindex krakatoa
	pdflatex krakatoa.tex
	pdflatex krakatoa.tex

jessie.pdf: sourcepp jessie.tex version.tex
	pdflatex jessie.tex
	bibtex jessie
	makeindex jessie
	pdflatex jessie.tex
	pdflatex jessie.tex

february2008.pdf: $(KFILES) version.tex
	pdflatex february2008.tex

krakatoa.html: krakatoa.tex version.tex
	rm -f krakatoa.aux
	$(HEVEA) krakatoa.tex

jessie.html: jessie.tex version.tex
	rm -f jessie.aux
	$(HEVEA) jessie.tex

main.html: main.tex version.tex
	rm -f main.aux
	$(HEVEA) main.tex


main.pdf: main.tex version.tex
	pdflatex main.tex


%.pp: %.tex pp
	./pp $< > $@

%.pp: %.c pp
	./pp -c $< > $@

%.pp: %.java pp
	./pp -java $< > $@

texpp/%.cpp: codes/%.c pp  Makefile
	mkdir -p texpp
	./pp -c $< > $@

%.dvi: %.tex
	latex $< && latex $<

%.ps: %.dvi
	dvips -o $@ $<

%.eps: %.dia
	dia --filter=eps-builtin $^

%.pdf: %.eps
	epstopdf $^

%.tex: %.dia
	dia --filter=tex $^

%.png: %.dia
	dia --filter=png --size=2048,1536 $^

%.bnf: %.tex tex2bnf
	./tex2bnf < $< > $@

tex2bnf: tex2bnf.ml
	ocamlopt.opt -o $@ $^

pp: pp.ml
	ocamlopt.opt -o $@ $^

%.ml: %.mll
	ocamllex.opt $<

clean::
	rm -f *~ *.dvi *.log *.aux *.toc \
		dep.ps doc.ps manual.ps caduceus.ps krakatoa.pdf main.pdf 
	rm -f *.cm*

=== examples-c/Makefile ===

DIRS = tutorial sorting g4 linked-lists schorr-waite

check:
	for d in $(DIRS); do make -C $$d check; done

all: 
	for d in $(DIRS); do \
		if make -C $$d coq; then \
			echo "Coq proofs OK in $$d" ; \
		else \
			echo "Coq proofs FAILED in $$d" ; \
			exit 1 ;\
		fi ; \
	done

bench:
	make -C tutorial allcoq
	for d in $(DIRS); do make -C $$d simplify; done

clean:
	for d in $(DIRS); do make -C $$d clean; done

=== examples/Makefile ===

DIRS = misc binary-search bresenham quicksort edit-distance heapsort sqrt kmp \
       selectionsort find quicksort2 maximumsort algo-63-64-65 dijkstra \
       mergesort queens

check: 
	for d in $(DIRS); do make -C $$d check; done

all: 
	for d in $(DIRS); do make -C $$d; done

simplify:
	for d in $(DIRS); do make -C $$d simplify; done

ergo:
	for d in $(DIRS); do make -C $$d ergo; done

clean::
	rm -f */*~ */*.vo

depend::
	for d in $(DIRS); do make -C $$d depend; done

=== frama-c-plugin/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2010                                               #
#    INRIA (Institut National de Recherche en Informatique et en         #
#           Automatique)                                                 #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Makefile for compiling Jessie independently of Frama-C.
#
# To be used independently of Frama-C, a version of Frama-C compatible with
# Jessie has to be properly installed as well as the Jessie-specific stuff.

# Do not use ?= to initialize both below variables
# (fixed efficiency issue, see GNU Make manual, Section 8.11)
ifndef FRAMAC_SHARE
FRAMAC_SHARE  :=$(shell frama-c -journal-disable -print-path)
endif
ifndef FRAMAC_LIBDIR
FRAMAC_LIBDIR :=$(shell frama-c -journal-disable -print-libpath)
endif

PLUGIN_DIR      ?= .
WHY_DISTRIB	?= $(PLUGIN_DIR)/..
JESSIE_INCLUDES	?= -I $(WHY_DISTRIB)/src -I $(WHY_DISTRIB)/jc
JCCMO		?= $(WHY_DISTRIB)/jc/jc.cmo
JCCMX		?= $(JCCMO:.cmo=.cmx)

PLUGIN_NAME:=Jessie
PLUGIN_CMO:= jessie_config jessie_options jessie_integer common rewrite \
             norm retype interp register
PLUGIN_HAS_MLI:=yes
PLUGIN_BFLAGS:=$(JESSIE_INCLUDES)
PLUGIN_OFLAGS:=$(JESSIE_INCLUDES)
PLUGIN_EXTRA_BYTE+=$(JCCMO)
PLUGIN_EXTRA_OPT+=$(JCCMX)
#PLUGIN_DEPFLAGS:=$(JESSIE_INCLUDES)
PLUGIN_DOCFLAGS:=$(JESSIE_INCLUDES)
PLUGIN_TESTS_DIRS:=jessie

ifeq ($(FRAMAC_MAKE),yes)
unexport $(FRAMAC_MAKE)

all::  $(WHY_DISTRIB)/Makefile $(WHY_DISTRIB)/.depend why_all

.PHONY: why_all $(WHY_DISTRIB)/depend $(WHY_DISTRIB)/clean
why_all: $(WHY_DISTRIB)/Makefile $(WHY_DISTRIB)/.depend $(PLUGIN_DIR)/interp.cmi
	$(MAKE) -C $(dir $<) -j 1 all-without-frama-c-plugin

$(WHY_DISTRIB)/depend: $(WHY_DISTRIB)/Makefile
	$(MAKE) -C $(dir $@) -j 1 depend FRAMAC=no

$(WHY_DISTRIB)/clean:
	$(MAKE) -C $(dir $@) -j 1 clean

$(PLUGIN_DIR)/.depend: $(WHY_DISTRIB)/.depend

depend:: $(WHY_DISTRIB)/depend

clean::$(WHY_DISTRIB)/clean

tests:: $(WHY_DISTRIB)/bin/jessie.$(OCAMLBEST) $(WHY_DISTRIB)/bin/why.$(OCAMLBEST)

endif

$(PLUGIN_DIR)/interp.cmo: $(PLUGIN_DIR)/interp.cmi $(WHY_DISTRIB)/jc/jc.cmo

$(PLUGIN_DIR)/interp.cmi: $(WHY_DISTRIB)/jc/jc.cmi

$(PLUGIN_DIR)/interp.cmx: $(PLUGIN_DIR)/interp.cmi $(WHY_DISTRIB)/jc/jc.cmx

$(WHY_DISTRIB)/jc/jc.cmo: $(WHY_DISTRIB)/jc/jc.cmi
$(WHY_DISTRIB)/jc/jc.cmx: $(WHY_DISTRIB)/jc/jc.cmi

$(PLUGIN_DIR)/jessie_config.ml:
	echo "let jessie_local = false" > $@

$(WHY_DISTRIB)/Makefile: $(WHY_DISTRIB)/Makefile.in $(WHY_DISTRIB)/config.status
	cd $(dir $@) && ./config.status

$(WHY_DISTRIB)/.depend: $(WHY_DISTRIB)/Makefile
	$(MAKE) -C $(dir $@) -j 1 .depend FRAMAC=no

$(WHY_DISTRIB)/config.status: $(WHY_DISTRIB)/configure
	if test -e $(dir $@)/config.status; then \
	  cd $(dir $@) && ./config.status -recheck; \
	else \
	 cd $(dir $@) && ./configure ; \
	fi

$(WHY_DISTRIB)/configure: $(WHY_DISTRIB)/configure.in
	cd $(dir $@) && autoconf

$(WHY_DISTRIB)/Makefile.in: ;
$(WHY_DISTRIB)/configure.in: ;

$(WHY_DISTRIB)/%: $(WHY_DISTRIB)/Makefile $(WHY_DISTRIB)/.depend
	$(MAKE) -C $(subst /$*,,$@) -j 1 $*

PLUGIN_GENERATED_LIST+=$(JESSIE_HOME_DIR)/jessie_config.ml

include $(FRAMAC_SHARE)/Makefile.dynamic

=== examples-c/g4/Makefile ===

CADUCEUS=../../bin/caduceus.opt
CADUCEUSLIB=$(shell pwd)/../../lib
EXECCADUCEUS=CADUCEUSLIB=$(CADUCEUSLIB) $(CADUCEUS)

FILES = g4

TODO = g4

check:
	for f in $(FILES); do caduceus $$f.c; done

coq: $(FILES)

allcoq:
	for f in $(FILES); do \
	  $(EXECCADUCEUS) $$f.c; \
	  make -f $$f.makefile depend; \
	  make -f $$f.makefile coq; \
	done

simplify:
	for f in $(FILES); do \
	  $(EXECCADUCEUS) $$f.c; \
	  make -f $$f.makefile simplify; \
	done

cvcl:
	for f in $(FILES); do \
	  $(EXECCADUCEUS) $$f.c; \
	  make -f $$f.makefile cvcl; \
	done

.PHONY: coq simplify cvcl

why/%.why: %.c 
	rm -f coq/caduceus_spec_why.v
	$(EXECCADUCEUS) $<

%: %.c
	rm -f why/$*.why
	make why/$*.why
	make -f $*.makefile coq

clean:
	make -f g4.makefile clean
	rm -f why/*.why

=== examples-c/linked-lists/Makefile ===

CADUCEUS=../../bin/caduceus.opt 
CADUCEUSLIB=$(shell pwd)/../../lib
EXECCADUCEUS=CADUCEUSLIB=$(CADUCEUSLIB) $(CADUCEUS)

FILES = swap reverse

check:
	for f in $(FILES); do caduceus $$f.c; done

all: swap reverse

reverse:
	$(EXECCADUCEUS) reverse.c
	make -f reverse.makefile simplify
	make -f reverse.makefile coq

swap:
	$(EXECCADUCEUS) swap.c
	make -f swap.makefile simplify
	make -f swap.makefile coq

simplify:
	for f in $(FILES); do \
	  $(EXECCADUCEUS) $$f.c; \
	  make -f $$f.makefile simplify; \
	done

%: %.c 
	$(EXECCADUCEUS) $*.c
	make -f $*.makefile simplify
	make -f $*.makefile coq

.PHONY: coq simplify cvcl

clean:
	make -f reverse.makefile clean
	make -f swap.makefile clean
	make -f has_cycle.makefile clean
	rm -f why/*.why

=== examples-c/puf/Makefile ===

all:
	caduceus -why-opt -split-user-conj parray.c puf.c
	make -f parray.makefile gui

=== examples-c/schorr-waite/Makefile ===

check:
	caduceus schorr_waite.c

all: schorr_waite

transparent.ps: transparent.dvi
	dvips transparent.dvi -o transparent.ps

transparent.pdf: transparent.dvi
	dvipdf transparent.dvi 

transparent.dvi: transparent.tex
	latex transparent

%: %.c 
	caduceus $*.c
	make -f $*.makefile simplify
	make -f $*.makefile depend
	make -f $*.makefile coq

schorr_waite_split:
	caduceus -why-opt "--split" schorr_waite_split.c
	make -f schorr_waite_split.makefile simplify

clean:
	make -f schorr_waite.makefile clean
	rm -f why/*.why

=== examples-c/sorting/Makefile ===

CADUCEUS=../../bin/caduceus.opt -why-opt -split-user-conj
CADUCEUSLIB=$(shell pwd)/../../lib
EXECCADUCEUS=CADUCEUSLIB=$(CADUCEUSLIB) $(CADUCEUS)

FILES = quicksort selection

TODO = selection

check:
	for f in $(FILES); do caduceus $$f.c; done

coq: $(FILES)

allcoq:
	for f in $(FILES); do \
	  $(EXECCADUCEUS) $$f.c; \
	  make -f $$f.makefile depend; \
	  make -f $$f.makefile coq; \
	done

simplify:
	for f in $(FILES); do \
	  $(EXECCADUCEUS) $$f.c; \
	  make -f $$f.makefile simplify; \
	done

gui:
	for f in $(FILES); do \
	  $(EXECCADUCEUS) $$f.c; \
	  make -f $$f.makefile gui; \
	done

cvcl:
	for f in $(FILES); do \
	  $(EXECCADUCEUS) $$f.c; \
	  make -f $$f.makefile cvcl; \
	done

.PHONY: coq simplify cvcl

why/%.why: %.c 
	rm -f coq/caduceus_spec_why.v
	$(EXECCADUCEUS) $<

%: %.c
	rm -f why/$*.why
	make why/$*.why
	make -f $*.makefile coq

clean:
	make -f selection.makefile clean
	rm -f why/*.why

=== examples-c/trees/Makefile ===

all:
	../../bin/caduceus.opt -why-opt -split-user-conj search.c
	make -f search.makefile gui

=== examples-c/tutorial/Makefile ===

CADUCEUS=../../bin/caduceus.opt
CADUCEUSLIB=$(shell pwd)/../../lib
EXECCADUCEUS=CADUCEUSLIB=$(CADUCEUSLIB) $(CADUCEUS)

FILES = max abs swap search purse binary_search

TODO = average

check:
	for f in $(FILES); do caduceus $$f.c; done

coq: $(FILES)

allcoq:
	for f in $(FILES); do \
	  caduceus $$f.c; \
	  rm -f coq/caduceus_spec_why.v; \
	  make -f $$f.makefile coq.depend; \
	  make -f $$f.makefile coq; \
	done

simplify:
	for f in $(FILES); do \
	  caduceus $$f.c; \
	  make -f $$f.makefile simplify; \
	done

cvcl:
	for f in $(FILES); do \
	  caduceus $$f.c; \
	  make -f $$f.makefile cvcl; \
	done

.PHONY: coq simplify cvcl

why/%.why: %.c 
	$(EXECCADUCEUS) $<

%: %.c
	rm -f why/$*.why
	make why/$*.why
	make -f $*.makefile gui

%.coq: %.c
	rm -f why/$*.why
	make why/$*.why
	make -f $*.makefile coq


clean:
	for f in $(FILES); do make -f $$f.makefile clean; done
	rm -f why/*.why

=== debian/changelog ===
why (2.34-4ubuntu4) xenial; urgency=medium

  * Disable the why+coq autopkg test.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 23 Feb 2016 16:34:34 +0100

why (2.34-4ubuntu3) xenial; urgency=medium

  * Drop build dependency on libfloat-coq, not buildable with the
    the current coq.
  * why still fails to build, so drop the the libwhy-coq binary
    and coq build dependency.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 23 Feb 2016 15:36:48 +0100

why (2.34-4ubuntu2) xenial; urgency=medium

  * Rebuild for new OCaml ABIs.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Feb 2016 12:07:26 +0000

why (2.34-4ubuntu1) xenial; urgency=medium

  * Rebase on Debian, remaining change:
    + debian/tests/control: Disable frama-c+jessie+alt-ergo test, since we
      don't have a jessie plugin currently (until we get 'why3')

 -- Iain Lane <iain@orangesquash.org.uk>  Wed, 04 Nov 2015 12:12:10 +0000

why (2.34-4) unstable; urgency=medium

  [ Ralf Treinen ]
  * improve as-installed package tests

  [ Mehdi Dogguy ]
  * Fix FTBFS with OCaml 4.02.3 by:
    - not using Format.bprintf anymore
    - not turning warning 3 into an error
  * Port Why to ocamlgraph 1.8.6

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 17 Oct 2015 01:12:21 +0200

why (2.34-2) unstable; urgency=medium

  * Team upload
  * Recompile with coq 8.4pl4
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Mon, 04 Aug 2014 09:34:24 +0200

why (2.34-1) unstable; urgency=low

  * New upstream release.
  * Drop deprecated patches:
    - deprecated-or
    - hashtbl
    - frama-c-versions
  * Bump build-dependency on frama-c to version 20140301+neon+dfsg.
  * Fix debian/tests/frama-c+jessie+alt-ergo:
    - run why-config when there is no ${HOME}/.whyrc
    - drop the specification of cpp-4.7 as this is no longer needed, and
      the dependency of that test on cpp-4.7
  
 -- Ralf Treinen <treinen@debian.org>  Tue, 29 Apr 2014 20:56:03 +0200

why (2.33-2) unstable; urgency=low

  * fixed typo in debian/tests/control (dependency of frama-c+jessie+alt-ergo)

 -- Ralf Treinen <treinen@debian.org>  Mon, 17 Feb 2014 08:40:19 +0100

why (2.33-1) unstable; urgency=low

  * New upstream release. This fixes an issue with compilation under
    ocaml-4.01 (closes: #707585).
  * Bump build-dependency on frama-c-base to the latest version 
    (closes: #730526)
  * Drop patches adopted or otherwise fixed by upstream:
    - 0001-Why-2.29-do-support-Coq-8.3.patch
    - 0002-Mark-alt-ergo-0.93-as-compatible.patch
    - 0003-Fix-non-exhaustive-pattern-matching-in-jc_annot_infe.patch
    - 0004-Default-to-why2-for-jessie-atp.patch
    - 0005-Fix-Jc_annot_inference-use-old_reg_pos.patch
    - 0006-Fix-spelling-error-in-binary.patch
    - 0007-Replace-caduceus-invocation-by-Frama-C.patch
  * New patch deprecated-or to replace "or" by "||", needed for more strict
    checks in ocaml 4
  * New patch hashtbl to fix compilation with ocaml 4.01, taken from fedora.
  * New patch atp-versions: update accepted versions of external provers:
    alt-ergo, coq
  * New patch frama-c-versions: update accepted version of frama-c
  * Add myself to uploaders.
  * Standards-Version 3.9.5 (no change)
  * Add DEP8-style package tests 
    - why with alt-ergo
    - why with cvc3
    - why with coq (thanks to Pierre Letouzey for his help!)
    - frama-c, jessie plugin (from the why package), and alt-ergo
  * Add to the Recommendation of package alt-ergo alternatives on other
    theorem provers: cvc3, coq

 -- Ralf Treinen <treinen@debian.org>  Tue, 04 Feb 2014 12:33:02 +0100

=== debian/control ===
Source: why
Section: math
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Samuel Mimram <smimram@debian.org>,
  Mehdi Dogguy <mehdi@debian.org>,
  Ralf Treinen <treinen@debian.org>
Build-Depends:
  debhelper (>= 7.0.50~),
  autotools-dev,
  autoconf,
  dh-ocaml (>= 0.9~),
  ocaml-nox (>= 3.11.1-3~),
  ocaml-best-compilers,
  camlp4,
  liblablgtk2-ocaml-dev (>= 2.12.0-3~),
  libocamlgraph-ocaml-dev (>= 1.4~),
  frama-c-base (>= 20140301+neon+dfsg),
  libapron-ocaml-dev (>= 0.9.10-4~),
  camlidl
Standards-Version: 3.9.5
Homepage: http://why.lri.fr/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/why.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/why.git
XS-Testsuite: autopkgtest

Package: why
Architecture: any
Depends:
  ${shlibs:Depends},
  ${ocaml:Depends},
  ${misc:Depends},
  frama-c-base (= ${F:FramaCVersion}),
  make
Suggests: libwhy-coq (= ${binary:Version})
Recommends: alt-ergo | cvc3 | coq
Description: Software verification tool
 Why aims at being a verification conditions generator (VCG) back-end
 for other verification tools. It provides a powerful input language
 including higher-order functions, polymorphism, references, arrays and
 exceptions. It generates proof obligations for many systems: the proof
 assistants Coq, PVS, Isabelle/HOL, HOL 4, HOL Light, Mizar and the
 decision procedures Simplify, Alt-Ergo, Yices, CVC Lite and haRVey.

Package: why-examples
Architecture: all
Depends:
  ${misc:Depends},
  why
Section: doc
Description: Examples of programs certified with Why
 Why aims at being a verification conditions generator (VCG) back-end
 for other verification tools. It provides a powerful input language
 including higher-order functions, polymorphism, references, arrays and
 exceptions. It generates proof obligations for many systems: the proof
 assistants Coq, PVS, Isabelle/HOL, HOL 4, HOL Light, Mizar and the
 decision procedures Simplify, Alt-Ergo, Yices, CVC Lite and haRVey.
 .
 This package contains examples of programs verified using Why.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

WHYDIR    = $(CURDIR)/debian/why
FRAMADIR  = $(WHYDIR)/$(shell frama-c -print-plugin-path)
FRAMAVER  = $(shell dpkg-query -W -f='$${Version}' frama-c-base)
VERSION   = $(shell cat Version | grep ^VERSION | cut -d= -f 2)
export OCAMLINIT_SED += -e 's/@VERSION@/$(VERSION)/g'

override_dh_auto_test:
	: # requires coq
	true

override_dh_auto_configure:
	autoconf
	./configure \
	    --host=$(DEB_HOST_GNU_TYPE) \
	    --build=$(DEB_BUILD_GNU_TYPE) \
	    --prefix=/usr \
	    --libdir=/usr/share \
	    --mandir=\$${prefix}/share/man \
	    --infodir=\$${prefix}/share/info \
	    --enable-apron=yes \
	    LDFLAGS="-Wl,-z,defs"

override_dh_auto_clean:
	[ ! -f Makefile ] || sed -e 's/include .depend.*//g' Makefile > Makefile.debian
	[ ! -f Makefile.debian ] || $(MAKE) -f Makefile.debian clean
	$(RM) -f lib/coq/*.glob

override_dh_auto_install:
	mkdir -p $(FRAMADIR)
	$(MAKE) prefix=$(WHYDIR)/usr install \
		LIBDIR=$(WHYDIR)/usr/share   \
		PLUGIN_INSTALL_DIR=$(WHYDIR)/usr/lib/frama-c/plugins \
		COQLIB=$(CURDIR)/debian/libwhy-coq/$(COQ_STDLIB_DIR)
	#Used to remove /usr/share/coq/jessie_why.v which is alone and installed by libwhy-coq
	-$(RM) -rf $(WHYDIR)/usr/share/coq/
	#There is no program using the Jessie library.
	-$(RM) -rf $(WHYDIR)/usr/share/jessie/
	#Jessie.cma is installed, no need for this extra file
	-$(RM) -f $(FRAMADIR)/Jessie.cmo
	echo 'F:FramaCVersion=$(FRAMAVER)' >> debian/why.substvars

override_dh_compress:
	dh_compress -X.v -X.sx -X.why

%:
	dh --with ocaml $@

#	dh_installchangelogs CHANGES

=== debian/tests/control ===
Tests: why+alt-ergo
Depends: why, alt-ergo

Tests: why+cvc3
Depends: why, cvc3

#Tests: why+coq
#Depends: why, libwhy-coq, coq

#Tests: frama-c+jessie+alt-ergo
#Depends: why, frama-c-base, alt-ergo

=== debian/watch ===
version=3

opts="dversionmangle=s/\.dfsg[\.0-9]*$//" \
http://why.lri.fr/download/why-([0-9a-z\.]*)\.tar\.gz

## why 2.36

=== frama-c-plugin/Makefile ===
--- 
+++ 
@@ -27,11 +27,12 @@
 
 # Do not use ?= to initialize both below variables
 # (fixed efficiency issue, see GNU Make manual, Section 8.11)
+FRAMAC ?= frama-c
 ifndef FRAMAC_SHARE
-FRAMAC_SHARE  :=$(shell frama-c -journal-disable -print-path)
+FRAMAC_SHARE  := $(shell $(FRAMAC) -journal-disable -print-path)
 endif
 ifndef FRAMAC_LIBDIR
-FRAMAC_LIBDIR :=$(shell frama-c -journal-disable -print-libpath)
+FRAMAC_LIBDIR := $(shell $(FRAMAC) -journal-disable -print-libpath)
 endif
 
 PLUGIN_DIR      ?= .
@@ -62,10 +63,10 @@
 	$(MAKE) -C $(dir $<) -j 1 all-without-frama-c-plugin
 
 $(WHY_DISTRIB)/depend: $(WHY_DISTRIB)/Makefile
-	$(MAKE) -C $(dir $@) -j 1 depend FRAMAC=no
+	$(MAKE) -C $(dir $@) -j 1 depend FRAMACPLUGIN=no
 
 $(WHY_DISTRIB)/clean:
-	$(MAKE) -C $(dir $@) -j 1 clean
+	$(MAKE) -C $(dir $@) -j 1 clean FRAMACPLUGIN=no
 
 $(PLUGIN_DIR)/.depend: $(WHY_DISTRIB)/.depend
 
@@ -93,7 +94,7 @@
 	cd $(dir $@) && ./config.status
 
 $(WHY_DISTRIB)/.depend: $(WHY_DISTRIB)/Makefile
-	$(MAKE) -C $(dir $@) -j 1 .depend FRAMAC=no
+	$(MAKE) -C $(dir $@) -j 1 .depend FRAMACPLUGIN=no
 
 $(WHY_DISTRIB)/config.status: $(WHY_DISTRIB)/configure
 	if test -e $(dir $@)/config.status; then \

## why 2.39

=== doc/Makefile ===
--- 
+++ 
@@ -54,8 +54,8 @@
 why_frama_c2-mps.pdf: why_frama_c2.mps
 	mptopdf why_frama_c2.mps 
 
-why_frama_c2-mps.png: why_frama_c2-mps.pdf
-	pdftoppm -r 150 why_frama_c2-mps.pdf | pnmtopng -transparent white > why_frama_c2-mps.png
+# why_frama_c2-mps.png: why_frama_c2-mps.pdf
+# 	pdftoppm -r 150 why_frama_c2-mps.pdf | pnmtopng -transparent white > why_frama_c2-mps.png
 
 dep.ps:
 	(cd ../src; ocamldep *.ml* | ocamldot | dot -Tps) > dep.ps

=== frama-c-plugin/Makefile ===
--- 
+++ 
@@ -45,8 +45,8 @@
 PLUGIN_CMO:= jessie_config jessie_options jessie_integer common rewrite \
              norm retype interp register
 PLUGIN_HAS_MLI:=yes
-PLUGIN_BFLAGS:=$(JESSIE_INCLUDES)
-PLUGIN_OFLAGS:=$(JESSIE_INCLUDES)
+PLUGIN_BFLAGS:=-w Aer-3-6-41-44-45-48-50-52-57 $(JESSIE_INCLUDES)
+PLUGIN_OFLAGS:=-w Aer-3-6-41-44-45-48-50-52-57 $(JESSIE_INCLUDES)
 PLUGIN_EXTRA_BYTE+=$(JCCMO)
 PLUGIN_EXTRA_OPT+=$(JCCMX)
 #PLUGIN_DEPFLAGS:=$(JESSIE_INCLUDES)
@@ -84,8 +84,8 @@
 
 $(PLUGIN_DIR)/interp.cmx: $(PLUGIN_DIR)/interp.cmi $(WHY_DISTRIB)/jc/jc.cmx
 
-$(WHY_DISTRIB)/jc/jc.cmo: $(WHY_DISTRIB)/jc/jc.cmi
-$(WHY_DISTRIB)/jc/jc.cmx: $(WHY_DISTRIB)/jc/jc.cmi
+# $(WHY_DISTRIB)/jc/jc.cmo: $(WHY_DISTRIB)/jc/jc.cmi
+# $(WHY_DISTRIB)/jc/jc.cmx: $(WHY_DISTRIB)/jc/jc.cmi
 
 $(PLUGIN_DIR)/jessie_config.ml:
 	echo "let jessie_local = false" > $@

=== debian/changelog ===
why (2.39-2build1) bionic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 16:44:41 +0200

why (2.39-2) unstable; urgency=medium

  * update Architecture list (closes: #875569)
    - changes due to ocaml 4.05: -armel +ppc64el +s390x
    - drop obsolete lpia
  * Standards-Version 4.1.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Thu, 12 Oct 2017 08:25:52 +0200

why (2.39-1) unstable; urgency=medium

  * New upstream version (closes: #872281)
  * Bumped build-dependency on frama-c-base to 20170501+phosphorus+dfsg
  * debian/copyright:
    - migrate to machine-readable format 1.0
    - fix upstream contact (Claude Marché)
  * Standards-Version 4.0.1 (no change)
  * Dropped build-dep on autotools-dev, which is obsolete with DH level 10.

 -- Ralf Treinen <treinen@debian.org>  Wed, 06 Sep 2017 21:34:58 +0200

why (2.38-1) unstable; urgency=medium

  * New upstream version (closes: #858366)
    - refreshed patches bprintf, edge
    - dropped hunks of patch reproducible_build that have been applied
      by upstream.
  * Bump build-dependency on frama-c-base to 20161101+silicon+dfsg
  * debian/why.install: install Jessie.o
  * Restrict Architecture of the why package to architectures having a
    native-code compiler for ocaml, since upstream ceased to maintain
    the why package for bytecode-only architectures.

 -- Ralf Treinen <treinen@debian.org>  Mon, 24 Apr 2017 08:25:31 +0200

why (2.36-5) unstable; urgency=medium

  * debian/rules: set FRAMADIR

 -- Ralf Treinen <treinen@debian.org>  Tue, 27 Dec 2016 13:13:18 +0100

why (2.36-4) unstable; urgency=medium

  * package tests: use /tmp when $ADT_ARTEFACTS is not set.
  * debian/rules: use $FRAMAVER variable when creating the META file

 -- Ralf Treinen <treinen@debian.org>  Tue, 27 Dec 2016 12:02:13 +0100

why (2.36-3) unstable; urgency=medium

  * drop build-dependency on liblablgtk2-ocaml-dev
  * stop using libapron, as advised by upstream:
    - drop build-dependency libapron-ocaml-dev
    - drop option enable-apron from ./configure invocation
  * generate frama-c-plugin/META.frama-c-jessie in debian/rules when it
    has not been generated by frama-c, which for some unknown reason
    happens on non-native architectures (closes: #844777).

 -- Ralf Treinen <treinen@debian.org>  Sun, 18 Dec 2016 19:22:16 +0100

why (2.36-2) unstable; urgency=medium

  * dh invocation: use --no-parallel to fix FTBFS issues
  * jessie manpage: fix synopsis

 -- Ralf Treinen <treinen@debian.org>  Wed, 12 Oct 2016 21:33:30 +0200

why (2.36-1) unstable; urgency=medium

  * New upstream release. This version compiles with coq 8.5
    and drops the gwhy binary (Closes: #440469).
    - refreshed patches bprintf and edge
    - dropped patch makefile as ocaml warning options are now set
      by configure
    - dropped patch atp-versions which is now obsolete
  * Due to disappearance of the why binary:
    - drop why-cpulimit manpage since this binary is no longer build:
      (files d/why-cpulimit.1 and d/why.manpages)
    - remove d/why.links as upstream does not ship the why manpage any more
    - add build-dependency on why3 and why3-coq
    - package why: add dependency on why3
    - d/tests/frama-c+jessie+alt-ergo: adapt to why3
    - package why: remove Recommends of SMT solvers
    - remove tests why+{alt-ergo,coq,cvc3}
    - rewrite package description
    - add why.NEWS entry about the transition to why3
  * Due to disappearance of doc/manual.ps and ocamlgraph/ from upstream:
    - remove d/purify-source
    - drop filter from d/gbp.conf
  * Due to disappearance of examples from upstream: don't build binary
    package why-examples
  * Patch reproducible_build: remove timestamps (closes: #807051).
    Thanks to Valentin Lorentz for the patch!
  * debian/control:
    - Dropped build-dependency on libfloat-coq (closes: #815684)
    - Bumped build-dependency on frama-c to magnesium.
    - Standards-Version 3.9.8 (no change)
    - d/control remove redundant XS-Testsuite field
    - Vcs-{Browser,Git}: use secure URI
  * debian/watch:
    - format version 4
    - get link to newest version from the krakatoa home page (instead of
      trying to read the download/ directory).
  * debhelper-compatibility level 10:
    - bump value in d/compat
    - build-depends on debhelper (>=10)
    - invocation of dh in d/rules: sequence argument before options
  * update homepage to krakatoa.lri.fr 
  * create manpages, based on the output of help2man, for jessie and krakatoa
  * drop autoconf from d/rules and from build-dependencies
  * d/rules: disable upstream tests
  * d/rules: create bin directory before invoking dh_auto_build
  * d/tests: add test krakato+alt-ergo
  * remove d/README.source which is obsolete.

 -- Ralf Treinen <treinen@debian.org>  Tue, 11 Oct 2016 21:28:06 +0200

=== debian/control ===
Source: why
Section: math
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Samuel Mimram <smimram@debian.org>,
  Mehdi Dogguy <mehdi@debian.org>,
  Ralf Treinen <treinen@debian.org>
Build-Depends:
  debhelper (>= 10),
  dh-ocaml (>= 0.9~),
  ocaml-nox (>= 3.11.1-3~),
  ocaml-best-compilers,
  camlp4,
  coq (>= 8.3~),
  libocamlgraph-ocaml-dev (>= 1.4~),
  frama-c-base (>= 20170501+phosphorus+dfsg),
  camlidl,
  why3, why3-coq
Standards-Version: 4.1.1
Homepage: http://krakatoa.lri.fr/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/why.git
Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/why.git

Package: why
Architecture: amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el sparc s390x
Depends:
  ${shlibs:Depends},
  ${ocaml:Depends},
  ${misc:Depends},
  frama-c-base (= ${F:FramaCVersion}),
  why3,
  make
Suggests: libwhy-coq (= ${binary:Version})
Description: Software verification tool for C and Java
 This package contains Krakatoa and Jessie, two front-ends of the Why3
 platform for deductive program verification. Krakatoa deals with Java
 programs annotated in a variant of the The Java Modeling
 Language. Jessie deals with C programs annotated in the ANSI/ISO C
 Specification Language (ACSL).
 
Package: libwhy-coq
Architecture: all
Depends:
  ${misc:Depends},
  coq-${F:CoqABI}
Replaces:
  why (<< 2.18.dfsg-1)
Section: libdevel
Description: Why library for Coq
 This package contains all useful logical definitions, lemmas with their
 proofs and axioms used by Why. Users may need this package when proving
 some proof obligations in Coq.

=== debian/rules ===
--- 
+++ 
@@ -4,19 +4,16 @@
 export DH_VERBOSE=1
 
 include /usr/share/ocaml/ocamlvars.mk
+include /usr/share/coq/coqvars.mk
 
 WHYDIR    = $(CURDIR)/debian/why
-FRAMADIR  = $(WHYDIR)/$(shell frama-c -print-plugin-path)
+#FRAMADIR  = $(WHYDIR)/$(shell frama-c -print-plugin-path)
+FRAMADIR  = $(WHYDIR)/usr/lib/frama-c/plugins
 FRAMAVER  = $(shell dpkg-query -W -f='$${Version}' frama-c-base)
 VERSION   = $(shell cat Version | grep ^VERSION | cut -d= -f 2)
 export OCAMLINIT_SED += -e 's/@VERSION@/$(VERSION)/g'
 
-override_dh_auto_test:
-	: # requires coq
-	true
-
 override_dh_auto_configure:
-	autoconf
 	./configure \
 	    --host=$(DEB_HOST_GNU_TYPE) \
 	    --build=$(DEB_BUILD_GNU_TYPE) \
@@ -24,7 +21,6 @@
 	    --libdir=/usr/share \
 	    --mandir=\$${prefix}/share/man \
 	    --infodir=\$${prefix}/share/info \
-	    --enable-apron=yes \
 	    LDFLAGS="-Wl,-z,defs"
 
 override_dh_auto_clean:
@@ -32,7 +28,22 @@
 	[ ! -f Makefile.debian ] || $(MAKE) -f Makefile.debian clean
 	$(RM) -f lib/coq/*.glob
 
-override_dh_auto_install:
+override_dh_auto_build:
+	mkdir -p bin
+	dh_auto_build
+
+frama-c-plugin/META.frama-c-jessie:
+	echo 'description = "Frama-C Jessie plug-in"' > $@
+	echo -n 'version = "' >> $@
+	echo -n $(FRAMAVER) >> $@
+	echo '"' >> $@
+	echo 'requires = ""' >> $@
+	echo 'archive(byte) = "Jessie.cma"' >> $@
+	echo 'archive(native) = "Jessie.cmxa"' >> $@
+	echo 'archive(plugin) = "Jessie.cmxs"' >> $@
+	echo 'directory = ""' >> $@
+
+override_dh_auto_install: frama-c-plugin/META.frama-c-jessie
 	mkdir -p $(FRAMADIR)
 	$(MAKE) prefix=$(WHYDIR)/usr install \
 		LIBDIR=$(WHYDIR)/usr/share   \
@@ -44,12 +55,15 @@
 	-$(RM) -rf $(WHYDIR)/usr/share/jessie/
 	#Jessie.cma is installed, no need for this extra file
 	-$(RM) -f $(FRAMADIR)/Jessie.cmo
+	echo 'F:CoqABI=$(COQ_ABI)' >> debian/libwhy-coq.substvars
 	echo 'F:FramaCVersion=$(FRAMAVER)' >> debian/why.substvars
 
 override_dh_compress:
 	dh_compress -X.v -X.sx -X.why
 
+override_dh_auto_test:
+
 %:
-	dh --with ocaml $@
+	dh $@ --with ocaml --no-parallel
 
 #	dh_installchangelogs CHANGES

=== debian/tests/control ===
Tests: frama-c+jessie+alt-ergo
Depends: why, alt-ergo

Tests: krakatoa+alt-ergo
Depends: why, alt-ergo

=== debian/watch ===
version=4

opts="dversionmangle=s/\.dfsg[\.0-9]*$//" \
http://krakatoa.lri.fr http://why.lri.fr/download/why-([0-9a-z\.]*)\.tar\.gz

## why 2.40

=== frama-c-plugin/Makefile ===
--- 
+++ 
@@ -47,6 +47,8 @@
 PLUGIN_HAS_MLI:=yes
 PLUGIN_BFLAGS:=-w Aer-3-6-41-44-45-48-50-52-57 $(JESSIE_INCLUDES)
 PLUGIN_OFLAGS:=-w Aer-3-6-41-44-45-48-50-52-57 $(JESSIE_INCLUDES)
+#PLUGIN_LINK_BFLAGS:=
+#PLUGIN_LINK_OFLAGS:=
 PLUGIN_EXTRA_BYTE+=$(JCCMO)
 PLUGIN_EXTRA_OPT+=$(JCCMX)
 #PLUGIN_DEPFLAGS:=$(JESSIE_INCLUDES)

=== debian/changelog ===
why (2.40-3build1) disco; urgency=medium

  * No-change rebuild against new frama-c-base

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 14 Nov 2018 20:48:16 -0800

why (2.40-3) unstable; urgency=medium

  * Update Architecture to native archs of ocaml 4.05:
    - drop armel (closes: #898493)
    - restore ppc64el, s390x (closes: #898518)
    - add ppc64

 -- Ralf Treinen <treinen@debian.org>  Sun, 13 May 2018 10:55:19 +0200

why (2.40-2) unstable; urgency=medium

  * Add build-dependency libzarith-ocaml-dev.

 -- Ralf Treinen <treinen@debian.org>  Sat, 12 May 2018 14:36:22 +0200

why (2.40-1) unstable; urgency=medium

  * New upstream version.
  * Bumped build-dependency on frama-c-base to 20171101+sulfur.
  * Updated Vcs-* fields to salsa.
  * d/control: dropped architecture lpia.
  * Bumped build-dependency on ocaml, following upstream's INSTALL.
  * Dropped build-dependency on ocaml-best-compilers.
  * Standards-Version 4.1.4 (no change).
  * Debhelper compatibility level 11.

 -- Ralf Treinen <treinen@debian.org>  Sat, 12 May 2018 09:21:13 +0200

=== debian/control ===
--- 
+++ 
@@ -1,28 +1,29 @@
 Source: why
 Section: math
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Samuel Mimram <smimram@debian.org>,
   Mehdi Dogguy <mehdi@debian.org>,
   Ralf Treinen <treinen@debian.org>
 Build-Depends:
-  debhelper (>= 10),
+  debhelper (>= 11),
   dh-ocaml (>= 0.9~),
-  ocaml-nox (>= 3.11.1-3~),
-  ocaml-best-compilers,
+  ocaml-nox (>= 4.02),
   camlp4,
   coq (>= 8.3~),
   libocamlgraph-ocaml-dev (>= 1.4~),
-  frama-c-base (>= 20170501+phosphorus+dfsg),
+  libzarith-ocaml-dev,
+  frama-c-base (>= 20171101+sulfur),
   camlidl,
   why3, why3-coq
-Standards-Version: 4.1.1
+Standards-Version: 4.1.4
 Homepage: http://krakatoa.lri.fr/
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/why.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/why.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/why
+Vcs-Git: https://salsa.debian.org/ocaml-team/why.git
 
 Package: why
-Architecture: amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el sparc s390x
+Architecture: amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64 powerpc ppc64 ppc64el sparc s390x
 Depends:
   ${shlibs:Depends},
   ${ocaml:Depends},
